import { Command } from "./index.d";
import { AxiosRequestConfig } from "axios";
/**
 * 异步执行命令，不支持交互式输入
 * @param {string}  cmd - 命令
 * @return {object} 命令的执行结果
 */
export declare function asyncCmder(cmd: string): Promise<any>;
/**
 * 同步执行命令，不支持交互式输入
 * @param {string}  cmd - 命令
 * @return {string}} 命令的执行结果
 */
export declare function cmder(cmd: string): string;
/**
 * 异步执行命令，支持交互式输入
 * @param {string}  cmd - 命令
 * @param {Array} arg - 命令的参数
 * @param {string} [content] - 可选参数，用户输入
 * @return {string} 命令的执行结果
 */
export declare function asyncSpawner(command: Command): Promise<any>;
/**
 * 同步执行命令，支持交互式输入
 * @param {string}  cmd - 命令
 * @param {Array} arg - 命令的参数
 * @param {object} [options] - 可选参数，object 类型
 * @return {string} 命令的执行结果
 */
export declare function spawner(command: Command): string;
/**
 * 获取 txt 文件内容
 * @param {string} filePath - 文件路径
 * @return {string} 文件内容
 */
export declare function getFileContent(filePath: string): string;
/**
 * 处理 http 请求
 */
export declare function httpRequest(config: AxiosRequestConfig): Promise<import("axios").AxiosResponse<any, any> | undefined>;
