"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.httpRequest = exports.getFileContent = exports.spawner = exports.asyncSpawner = exports.cmder = exports.asyncCmder = void 0;
var tslib_1 = require("tslib");
var fs = require("fs");
var path_1 = (0, tslib_1.__importDefault)(require("path"));
var util = require("util");
var child_process_1 = require("child_process");
var axios_1 = (0, tslib_1.__importDefault)(require("axios"));
/**
 * 异步执行命令，不支持交互式输入
 * @param {string}  cmd - 命令
 * @return {object} 命令的执行结果
 */
function asyncCmder(cmd) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var result;
        return (0, tslib_1.__generator)(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, util.promisify(child_process_1.exec)(cmd)];
                case 1:
                    result = _a.sent();
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.asyncCmder = asyncCmder;
/**
 * 同步执行命令，不支持交互式输入
 * @param {string}  cmd - 命令
 * @return {string}} 命令的执行结果
 */
function cmder(cmd) {
    var result = (0, child_process_1.execSync)(cmd).toString();
    return result;
}
exports.cmder = cmder;
/**
 * 异步执行命令，支持交互式输入
 * @param {string}  cmd - 命令
 * @param {Array} arg - 命令的参数
 * @param {string} [content] - 可选参数，用户输入
 * @return {string} 命令的执行结果
 */
function asyncSpawner(command) {
    var e_1, _a;
    var _b, _c;
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var sp, result, _d, _e, chunk, e_1_1;
        return (0, tslib_1.__generator)(this, function (_f) {
            switch (_f.label) {
                case 0:
                    sp = (0, child_process_1.spawn)(command.cmd, command.args);
                    if ((_b = command.options) === null || _b === void 0 ? void 0 : _b.input) {
                        sp.stdin.write((_c = command.options) === null || _c === void 0 ? void 0 : _c.input);
                        sp.stdin.end();
                    }
                    _f.label = 1;
                case 1:
                    _f.trys.push([1, 6, 7, 12]);
                    _d = (0, tslib_1.__asyncValues)(sp.stdout);
                    _f.label = 2;
                case 2: return [4 /*yield*/, _d.next()];
                case 3:
                    if (!(_e = _f.sent(), !_e.done)) return [3 /*break*/, 5];
                    chunk = _e.value;
                    result = chunk.toString();
                    _f.label = 4;
                case 4: return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 12];
                case 6:
                    e_1_1 = _f.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 7:
                    _f.trys.push([7, , 10, 11]);
                    if (!(_e && !_e.done && (_a = _d.return))) return [3 /*break*/, 9];
                    return [4 /*yield*/, _a.call(_d)];
                case 8:
                    _f.sent();
                    _f.label = 9;
                case 9: return [3 /*break*/, 11];
                case 10:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 11: return [7 /*endfinally*/];
                case 12: return [2 /*return*/, result];
            }
        });
    });
}
exports.asyncSpawner = asyncSpawner;
/**
 * 同步执行命令，支持交互式输入
 * @param {string}  cmd - 命令
 * @param {Array} arg - 命令的参数
 * @param {object} [options] - 可选参数，object 类型
 * @return {string} 命令的执行结果
 */
function spawner(command) {
    var result = (0, child_process_1.spawnSync)(command.cmd, command.args, command.options).stdout.toString();
    return result;
}
exports.spawner = spawner;
/**
 * 获取 txt 文件内容
 * @param {string} filePath - 文件路径
 * @return {string} 文件内容
 */
function getFileContent(filePath) {
    var content = fs.readFileSync(path_1.default.resolve(filePath), "utf-8");
    return content;
}
exports.getFileContent = getFileContent;
/**
 * 处理 http 请求
 */
function httpRequest(config) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var data, error_1;
        return (0, tslib_1.__generator)(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, axios_1.default.request(config)];
                case 1:
                    data = _a.sent();
                    return [2 /*return*/, data];
                case 2:
                    error_1 = _a.sent();
                    console.log(error_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.httpRequest = httpRequest;
//# sourceMappingURL=helper.js.map